/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.velocitycore.mods;

import com.google.gson.JsonArray;
import com.google.gson.JsonObject;
import com.velocitypowered.api.proxy.Player;
import com.velocitypowered.api.proxy.messages.MinecraftChannelIdentifier;

public class Feather {
    //https://github.com/Koupah/Feather-Client-API/blob/main/src/club/koupah/feather/packets/FeatherMod.java
    //https://archive.org/details/feather-server-api
    public static final String CHANNEL = "feather:client";

    private final byte[] packet;

    public Feather() {
        JsonArray array = new JsonArray();
        array.add("clearWater");
        array.add("coordinates");
        array.add("coordinates");
        array.add("hitbox");
        array.add("hypixel");
        array.add("reachDisplay");
        array.add("snaplook");
        array.add("toggleSprint");

        JsonObject mods = new JsonObject();
        mods.add("mods", array);

        JsonObject obj = new JsonObject();
        obj.addProperty("packetType", "DISABLE_MODS");
        obj.add("payload", mods);

        packet = obj.toString().getBytes();
    }

    public void sendRestrictions(Player player) {
        player.sendPluginMessage(MinecraftChannelIdentifier.from(CHANNEL), packet);
    }
}
